//---------------------------------------------------------------------------

#ifndef MainFormH
#define MainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ActnList.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
//---------------------------------------------------------------------------

#include "TextEditor.h"
#include <Dialogs.hpp>
#include <ExtDlgs.hpp>
#include <StdActns.hpp>
#include <ImgList.hpp>
#include <System.Actions.hpp>

/*
	This is also defined in the project file. Should really be put into
	a shared .h file or something.
*/
struct TMemoryMappedData
{
	HANDLE hApp;
	HANDLE hWin;
	ShortString CmdLine;
};

// Defined in the WinMain file
extern unsigned int MultiEditMsg;
extern TMemoryMappedData *pMemoryMappedData;

class TfrmMultiEditorMain : public TForm
{
__published:	// IDE-managed Components
	TMainMenu *mnuMain;
	TActionList *lstActions;
	TStatusBar *barStatus;
	TToolBar *barMainTools;
	TPanel *pnlEditor;
	TPageControl *pgeEditors;
	TFileOpen *actFileOpen;
	TSaveDialog *dlgFileSave;
	TFontDialog *dlgFont;
	TMenuItem *mnuFile;
	TMenuItem *mnuFileNew;
	TMenuItem *mnuFileOpen;
	TMenuItem *N1;
	TMenuItem *mnuFileExit;
	TAction *actFileNew;
	TImageList *lstImages;
	TToolButton *tbtnFileNew;
	TToolButton *tbtnFileOpen;
	TToolButton *tbtnFileClose;
	TFileExit *actFileExit;
	TAction *actFileClose;
	TMenuItem *mnuFileClose;
	TFileSaveAs *actFileSaveAs;
	TMenuItem *mnuFileSaveAs;
	TMenuItem *N2;
	TAction *actFileCloseAll;
	TMenuItem *mnuFileCloseAll;
	TAction *actFileSave;
	TMenuItem *mnuFileSave;
	TAction *actFileSaveAll;
	TMenuItem *mnuFileSaveAll;
	TMenuItem *mnuHelp;
	TAction *actHelpAbout;
	TMenuItem *mnuHelpAbout;
	TEditCut *actEditCut;
	TEditCopy *actEditCopy;
	TEditPaste *actEditPaste;
	TEditSelectAll *actEditSelectAll;
	TEditUndo *actEditUndo;
	TEditDelete *actEditDelete;
	TMenuItem *mnuEdit;
	TMenuItem *mnuEditUndo;
	TAction *actEditRedo;
	TMenuItem *mnuEditRedo;
	TMenuItem *N3;
	TMenuItem *mnuEditCut;
	TMenuItem *mnuEditCopy;
	TMenuItem *mnuEditPaste;
	TMenuItem *mnuEditDelete;
	TMenuItem *mnuEditSelectAll;
	TMenuItem *N4;
	TAction *actEditSelectFont;
	TMenuItem *mnuEditSelectFont;
	TToolButton *tbtnFileSave;
	TToolButton *tbtnFileSaveAs;
	TToolButton *ToolButton9;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall pgeEditorsMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall pgeEditorsChange(TObject *Sender);
	void __fastcall actFileNewExecute(TObject *Sender);
	void __fastcall actFileExitHint(AnsiString &HintStr, bool &CanShow);
	void __fastcall actFileCloseExecute(TObject *Sender);
	void __fastcall actEditSelectFontExecute(TObject *Sender);
	void __fastcall actFileOpenAccept(TObject *Sender);
	void __fastcall actFileSaveExecute(TObject *Sender);
	void __fastcall actFileSaveAsAccept(TObject *Sender);
	void __fastcall actHelpAboutExecute(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall actFileCloseAllExecute(TObject *Sender);
	void __fastcall actFileOpenBeforeExecute(TObject *Sender);
private:	// User declarations
	TObjectList *FTextEditors;
	TTextEditor *FActiveEditor;
	bool FIsClosing;
	TFont *FFont;
	int FUntitledFilesCount;

		// Our message handler for dropped files
	void __fastcall WMDropFiles(TWMDropFiles &Message);
	void CreateNewEditor(const AnsiString& Filename = "", bool load = true);
	bool CloseEditor(int index);
	bool CloseAllEditors(void);

	TTextEditor *GetActiveEditor(void);
	void ReadParams(void);

public:
	__fastcall TfrmMultiEditorMain(TComponent* Owner);
	__fastcall ~TfrmMultiEditorMain(void);
	virtual void __fastcall DefaultHandler(void *Message);

	// This is to be compatible with Microsoft
BEGIN_MESSAGE_MAP
MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
END_MESSAGE_MAP(TForm)

};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMultiEditorMain *frmMultiEditorMain;
//---------------------------------------------------------------------------
#endif
